searchNodes=[{"doc":"A LiveComponent for authentication via WebAuthn API. Authentication = Sign In Authentication is the process of matching a registered key to an existing user. See USAGE.md for example code. Assigns @challenge : (Internal) A Wax.Challenge struct created by the component, used to request an existing credential in the client. @class (Optional) CSS classes for overriding the default button style. @disabled (Optional) Set to true when the SupportHook indicates WebAuthn is not supported or enabled by the browser. Defaults to false . @id (Optional) An HTML element ID. Events &quot;authenticate&quot; : Triggered when a user clicks the authenticate button. &quot;authentication-challenge&quot; : Sent from the component to the client to request an existing credential registered to the endpoint URL. &quot;authentication-attestation&quot; : Sent by the client when a credential has been registered to the endpoint URL and activated by the user. &quot;error&quot; Sent by the client when an error occurs. Messages {:find_credentials, user_handle: user_handle} user_handle is a raw binary representing the user id or random id stored in the credential during registration. The parent LiveView must successfully lookup the user with this data before storing a token and redirecting to another view. {:error, payload} payload contains the message , name , and stack returned by the browser upon timeout or other client-side errors. Errors should be displayed to the user via Phoenix.LiveView.put_flash/3 . However, some errors may be too technical or cryptic to be useful to users, so the parent LiveView may paraphrase the message for clarity.","ref":"WebauthnComponents.AuthenticationComponent.html","title":"WebauthnComponents.AuthenticationComponent","type":"module"},{"doc":"Callback implementation for Phoenix.LiveComponent.handle_event/3 .","ref":"WebauthnComponents.AuthenticationComponent.html#handle_event/3","title":"WebauthnComponents.AuthenticationComponent.handle_event/3","type":"function"},{"doc":"Callback implementation for Phoenix.LiveComponent.mount/1 .","ref":"WebauthnComponents.AuthenticationComponent.html#mount/1","title":"WebauthnComponents.AuthenticationComponent.mount/1","type":"function"},{"doc":"Callback implementation for Phoenix.LiveComponent.render/1 .","ref":"WebauthnComponents.AuthenticationComponent.html#render/1","title":"WebauthnComponents.AuthenticationComponent.render/1","type":"function"},{"doc":"Custom Ecto.Type for WebAuthn cose keys. Use this type for the :public_key field in an Ecto schema. Example defmodule MyApp.Authentication.UserKey do use Ecto.Schema import Ecto.Changeset alias MyApp.Accounts.User alias WebauthnComponents.CoseKey @primary_key { :id , :binary_id , autogenerate : true } @foreign_key_type :binary_id @derive { Jason.Encoder , only : [ :key_id , :public_key , :label , :last_used ] } schema &quot;user_keys&quot; do field :label , :string , default : &quot;default&quot; field :key_id , :binary field :user_handle , :binary field :public_key , CoseKey belongs_to :user , User field :last_used , :utc_datetime timestamps ( ) end ... end","ref":"WebauthnComponents.CoseKey.html","title":"WebauthnComponents.CoseKey","type":"module"},{"doc":"Callback implementation for Ecto.Type.cast/1 .","ref":"WebauthnComponents.CoseKey.html#cast/1","title":"WebauthnComponents.CoseKey.cast/1","type":"function"},{"doc":"Callback implementation for Ecto.Type.dump/1 .","ref":"WebauthnComponents.CoseKey.html#dump/1","title":"WebauthnComponents.CoseKey.dump/1","type":"function"},{"doc":"Callback implementation for Ecto.Type.embed_as/1 .","ref":"WebauthnComponents.CoseKey.html#embed_as/1","title":"WebauthnComponents.CoseKey.embed_as/1","type":"function"},{"doc":"Callback implementation for Ecto.Type.equal?/2 .","ref":"WebauthnComponents.CoseKey.html#equal?/2","title":"WebauthnComponents.CoseKey.equal?/2","type":"function"},{"doc":"Callback implementation for Ecto.Type.load/1 .","ref":"WebauthnComponents.CoseKey.html#load/1","title":"WebauthnComponents.CoseKey.load/1","type":"function"},{"doc":"Callback implementation for Ecto.Type.type/0 .","ref":"WebauthnComponents.CoseKey.html#type/0","title":"WebauthnComponents.CoseKey.type/0","type":"function"},{"doc":"A LiveComponent for registering a new Passkey via the WebAuthn API. Registration = Sign Up Registration is the process of creating and associating a new key with a user account. Depending on your implementation, a new user may register a new account using only a Passkey, which does not require username or email. Existing users may also register additional keys for backup, survivorship, sharing, or other purposes. Your application may set limits on how many keys are associated with an account based on business concerns. See USAGE.md for example code. Assigns @challenge : (Internal) A Wax.Challenge struct created by the component, used to create a new credential request in the client. @class (Optional) CSS classes for overriding the default button style. @disabled (Optional) Set to true when the SupportHook indicates WebAuthn is not supported or enabled by the browser. Defaults to false . @id (Optional) An HTML element ID. @require_resident_key (Optional) Set to false to allow non-passkey credentials. Defaults to true . @user : (Optional) A map or struct containing an id , username or email , and display_name . If no user is provided, a random id will be generated, which will be encoded as the user_handle during registration. Events The following events are handled internally by RegistrationComponent : &quot;register&quot; : Triggered when a user clicks the register button. &quot;registration-challenge&quot; : Sent from the component to the client to request credential registration for the endpoint URL. &quot;registration-attestation&quot; Sent by the client when a registration attestation has been created. &quot;error&quot; Sent by the client when an error occurs. Messages This component handles communication between the client, manages its own state, and communicates with the parent LiveView when registration is successful. Errors are also reported to the parent LiveView when the client pushes an error, or when registration fails. The following messages must be handled by the parent LiveView using Phoenix.LiveView.handle_info/2 : {:registration_successful, key_id: raw_id, public_key: public_key, user_handle: user_handle} :key_id is a raw binary containing the credential id created by the browser. :public_key is a map of raw binaries which may be used later for authentication. :user_handle is a raw binary representing the provided user id, or a randomly generated uuid. These values must be persisted by the parent application in order to be used later during authentication. {:registration_failure, message: message} :message is an exception message returned by Wax when registration fails. {:error, payload} payload contains the message , name , and stack returned by the browser upon timeout or other client-side errors. Errors should be displayed to the user via Phoenix.LiveView.put_flash/3 . However, some errors may be too technical or cryptic to be useful to users, so the parent LiveView may paraphrase the message for clarity.","ref":"WebauthnComponents.RegistrationComponent.html","title":"WebauthnComponents.RegistrationComponent","type":"module"},{"doc":"Callback implementation for Phoenix.LiveComponent.handle_event/3 .","ref":"WebauthnComponents.RegistrationComponent.html#handle_event/3","title":"WebauthnComponents.RegistrationComponent.handle_event/3","type":"function"},{"doc":"Callback implementation for Phoenix.LiveComponent.mount/1 .","ref":"WebauthnComponents.RegistrationComponent.html#mount/1","title":"WebauthnComponents.RegistrationComponent.mount/1","type":"function"},{"doc":"Callback implementation for Phoenix.LiveComponent.render/1 .","ref":"WebauthnComponents.RegistrationComponent.html#render/1","title":"WebauthnComponents.RegistrationComponent.render/1","type":"function"},{"doc":"A LiveComponent for detecting WebAuthn support. This component should be used in combination with RegistrationComponent and AuthenticationComponent to disable their buttons when WebAuthn is not supported or enabled. An application may also use SupportComponent to steer users away from traditional authentication to the more secure Passkey authentication method. For example, an application that supports both traditional authentication and Passkeys may redirect users to a Passkey LiveView or render a message encouraging the new authentication method. See USAGE.md for example code. Assigns @id (Optional) An HTML element ID. @passkeys_supported : (Internal) A boolean indicating the client does or does not support the WebAuthn API. Events &quot;passkeys-supported&quot; : Sent by the client when Passkey support has been checked. Messages {:passkeys_supported, boolean} boolean will be true when WebAuthn is supported and enabled, and false when it is not supported or enabled.","ref":"WebauthnComponents.SupportComponent.html","title":"WebauthnComponents.SupportComponent","type":"module"},{"doc":"Callback implementation for Phoenix.LiveComponent.handle_event/3 .","ref":"WebauthnComponents.SupportComponent.html#handle_event/3","title":"WebauthnComponents.SupportComponent.handle_event/3","type":"function"},{"doc":"Callback implementation for Phoenix.LiveComponent.mount/1 .","ref":"WebauthnComponents.SupportComponent.html#mount/1","title":"WebauthnComponents.SupportComponent.mount/1","type":"function"},{"doc":"Callback implementation for Phoenix.LiveComponent.render/1 .","ref":"WebauthnComponents.SupportComponent.html#render/1","title":"WebauthnComponents.SupportComponent.render/1","type":"function"},{"doc":"A LiveComponent for handling session tokens. TokenComponent manages the client-side session token, allowing the parent LiveView to do the following: Redirect when a user is already signed in. Store a new token upon registration or authentication. Clear a token upon sign-out. See USAGE.md for example code. Assigns @id (Optional) An HTML element ID. @token : A Base64-encoded session token to be stored in the client. The parent LiveView may use Phoenix.LiveView.send_update/3 to set or clear a token in the client. Clear a Token send_update ( TokenComponent , id : &quot;token-component&quot; , token : :clear ) Store a Token send_update ( TokenComponent , id : &quot;token-component&quot; , token : base64_encoded_token ) Events The following events are handled internally by TokenComponent : &quot;token-exists&quot; : Sent by the client when sessionStorage contains a userToken . &quot;token-stored&quot; : Sent by the client when a token has been stored in sessionStorage . &quot;token-cleared&quot; : Sent by the client when a token has been cleared from sessionStorage . &quot;error&quot; : Sent by the client when an error occurs. Messages {:token_exists, token: token} :token is a Base64-encoded token found by the client. The parent LiveView may use this token to authenticate users. {:token_stored, token: token} :token is a Base64-encoded token stored by the client. The parent LiveView may compare the returned token against the token sent to the component to ensure there has been no tampering. {:token_cleared} A token has been cleared from the client. {:error, payload} payload contains the message , name , and stack returned by the browser upon timeout or other client-side errors.","ref":"WebauthnComponents.TokenComponent.html","title":"WebauthnComponents.TokenComponent","type":"module"},{"doc":"Callback implementation for Phoenix.LiveComponent.handle_event/3 .","ref":"WebauthnComponents.TokenComponent.html#handle_event/3","title":"WebauthnComponents.TokenComponent.handle_event/3","type":"function"},{"doc":"Callback implementation for Phoenix.LiveComponent.mount/1 .","ref":"WebauthnComponents.TokenComponent.html#mount/1","title":"WebauthnComponents.TokenComponent.mount/1","type":"function"},{"doc":"Callback implementation for Phoenix.LiveComponent.render/1 .","ref":"WebauthnComponents.TokenComponent.html#render/1","title":"WebauthnComponents.TokenComponent.render/1","type":"function"},{"doc":"Stores or clears a session token. When a :token assign is received, this function will either clear or store the user's token. Assign token: :clear to remove a user's token. Assign a binary token (typically a base64-encoded crypto hash) to persist a user's token to the browser's sessionStorage . Invalid token assigns will be logged and the socket will be returned unchanged.","ref":"WebauthnComponents.TokenComponent.html#update/2","title":"WebauthnComponents.TokenComponent.update/2","type":"function"},{"doc":"A collection of drop-in LiveComponents for password-less authentication. Status: Beta 💅🏻 Please do not use WebauthnComponents in a production environment until it has completed beta testing. This package is a work in progress , and it is in early beta status. Feel free to experiment with this package and contribute feedback through GitHub discussions or the related topic in Elixir Forum .","ref":"readme.html","title":"WebauthnComponents","type":"extras"},{"doc":"View the planned work for this repo in the public WebauthnComponents v1 project on GitHub.","ref":"readme.html#roadmap","title":"WebauthnComponents - Roadmap","type":"extras"},{"doc":"During the beta phase, generators will be added to streamline initial setup, including running migrations, generating related modules, etc. Steps marked (TODO) need additional documentation, and some may be streamlined by Mix tasks during the beta phase. Add Mix dependency Add WebAuthn hook to app.js Run Mix task to create user_keys schema &amp; migration mix phx.gen.context --binary-id Authentication UserKey user_keys key_id:binary label last_used:utc_datetime public_key:binary user_id:references:users Update UserKey schema (TODO) Add default value to the label field Update the public_key field to use WebauthnComponents.CoseKey as its type Add new_changeset/2 &amp; update_changeset/2 (TODO) Run Mix task to create user_tokens schema &amp; migration mix phx.gen.context --binary-id Authentication UserToken user_tokens user_id:references:users token:binary context Update UserToken schema Update the context field to use Ecto.Enum as its type with values: [:session, :device_code] and default: :session Replace user_id field with belongs_to User association Add foreign_key_constraint :user_id Add token helper functions (TODO) Update User and/or relevant schemas to include keys association (TODO) Installation Add webauthn_components to your list of dependencies in mix.exs : def deps do [ { :webauthn_components , &quot;~&gt; 0.3&quot; } ] end Usage See USAGE.md for detailed usage instructions. WebAuthn Flows WebauthnComponents contains a few modular components which may be combined to detect passkey support, register new keys, authenticate keys for existing users, and manage session tokens in the client. See module documentation for each component for more detailed descriptions. Support Detection sequenceDiagram autonumber participant Client participant SupportComponent participant ParentLiveView participant RegistrationComponent participant AuthenticationComponent Client-&gt;&gt;SupportComponent: &quot;passkeys-supported&quot; SupportComponent-&gt;&gt;ParentLiveView: `{:passkeys_supported, boolean}` ParentLiveView-&gt;&gt;RegistrationComponent: `@disabled = !@passkeys_supported` ParentLiveView-&gt;&gt;AuthenticationComponent: `@disabled = !@passkeys_supported` Registration Sign Up sequenceDiagram autonumber actor User participant Client participant RegistrationComponent participant ParentLiveView User-&gt;&gt;Client: Click `register` Client-&gt;&gt;RegistrationComponent: &quot;register&quot; RegistrationComponent-&gt;&gt;Client: &quot;registration-challenge&quot; Client-&gt;&gt;RegistrationComponent: &quot;registration-attestation&quot; RegistrationComponent-&gt;&gt;ParentLiveView: `{:registration_successful, ...}` Once the parent LiveView receives the {:registration_successful, ...} message, it must persist the user, the user's new key. To keep the user signed in, the LiveView may create a session token , Base64-encode the token, and pass it to TokenComponent for persistence in the client's sessionStorage . Token Management Successful Sign Up / Sign In sequenceDiagram autonumber participant Client participant TokenComponent participant ParentLiveView ParentLiveView-&gt;&gt;TokenComponent: `@token = b64_token` TokenComponent-&gt;&gt;Client: &quot;store-token&quot; Client-&gt;&gt;TokenComponent: &quot;token-stored&quot; TokenComponent-&gt;&gt;ParentLiveView: `{:token_stored, ...}` Active Session sequenceDiagram autonumber participant Client participant TokenComponent participant ParentLiveView Client-&gt;&gt;TokenComponent: &quot;token-exists&quot; TokenComponent-&gt;&gt;ParentLiveView: `{:token_exists, ...}` ParentLiveView--&gt;ParentLiveView: &quot;[user lookup by token]&quot; Sign Out sequenceDiagram autonumber participant Client participant TokenComponent participant ParentLiveView ParentLiveView-&gt;&gt;TokenComponent: `@token = :clear` TokenComponent-&gt;&gt;Client: &quot;clear-token&quot; Client-&gt;&gt;TokenComponent: &quot;token-cleared&quot; TokenComponent-&gt;&gt;ParentLiveView: `{:token_cleared}` Authentication Sign In sequenceDiagram autonumber actor User participant Client participant AuthenticationComponent participant ParentLiveView User-&gt;&gt;Client: Click `authenticate` Client-&gt;&gt;AuthenticationComponent: &quot;authenticate&quot; AuthenticationComponent-&gt;&gt;Client: &quot;authentication-challenge&quot; Client-&gt;&gt;AuthenticationComponent: &quot;authentication-attestation&quot; AuthenticationComponent-&gt;&gt;ParentLiveView: `{:find_credentials, ...}` Once the parent LiveView receives the {:find_credentials, ...} message, it must lookup the user via the user's existing key. To keep the user signed in, the LiveView may create a session token , Base64-encode the token, and pass it to TokenComponent for persistence in the client's sessionStorage .","ref":"readme.html#quick-start","title":"WebauthnComponents - Quick Start","type":"extras"},{"doc":"The Web Authentication API is an extension of the Credential Management API that enables strong authentication with public key cryptography, enabling passwordless authentication and/or secure second-factor authentication without SMS texts. https://developer.mozilla.org/en-US/docs/Web/API/Web_Authentication_API A passkey is a FIDO login credential, tied to an origin (website or application) and a physical device. Passkeys allow users to authenticate without having to enter a username, password, or provide any additional authentication factor. This technology aims to replace passwords as the primary authentication mechanism. https://developers.google.com/identity/fido Passkeys are essentially a standard to sync WebAuthn credentials with cloud platforms like iCloud Keychain , Android , 1Password , with more to come. Benefits There are many benefits to users and application maintainers when passwords are decommissioned. Eliminates password reuse by users. Mitigates credential stuffing attacks by hackers. Eliminates phishing attacks by hackers. For users on a device with Passkey support, WebAuthn credentials may be stored in the cloud. This allows the user to authenticate from other cloud-connected devices without registering each device individually. Known Issues While WebAuthn provides an API for improved authentication security, there are a few limitations to consider before adopting this component. As of 2022, Passkeys are not universally supported. If a user registers or authenticates on a device without Passkey support, the generated key pair will not be synced, and each device must be registered in order to access an account. Cloud-synced credentials are only accessible to devices authenticated to the cloud account. For example, a credential saved to iCloud Keychain will not be synced automatically to Android's credential manager.","ref":"readme.html#webauthn-passkeys","title":"WebauthnComponents - WebAuthn &amp; Passkeys","type":"extras"},{"doc":"The WebAuthn API has broad support across the most common modern browsers. https://caniuse.com/?search=webauthn","ref":"readme.html#browser-support","title":"WebauthnComponents - Browser Support","type":"extras"},{"doc":"https://webauthn.guide/ https://developer.mozilla.org/en-US/docs/Web/API/Web_Authentication_API https://fidoalliance.org/fido2-2/fido2-web-authentication-webauthn/ https://www.w3.org/TR/webauthn-2/","ref":"readme.html#additional-resources","title":"WebauthnComponents - Additional Resources","type":"extras"},{"doc":"WebauthnComponents are designed to be modular, providing flexibility to developers. However, SupportComponent should always be rendered along with RegistrationComponent and AuthenticationComponent to detect WebAuthn support on the client. A parent LiveView may also want to redirect users or clear tokens when users enter a page using the registration or authentication component. In these cases, render TokenComponent and implement its required message handlers to manage client-side session tokens.","ref":"usage.html","title":"Usage","type":"extras"},{"doc":"Usage Contents Combined Example SupportComponent TokenComponent RegistrationComponent Authentication Component","ref":"usage.html#contents","title":"Usage - Contents","type":"extras"},{"doc":"The following AuthLive example demonstrates how to compose the components to detect support, register, authenticate, and manage tokens in a single LiveView. defmodule MyAppWeb.AuthLive do use Phoenix.LiveView alias WebauthnComponents.AuthenticationComponent alias WebauthnComponents.RegistrationComponent alias WebauthnComponents.SupportComponent alias WebauthnComponents.TokenComponent def mount ( _session , _params , socket ) do { :ok , socket |&gt; assign ( :passkeys_supported , fn -&gt; nil end ) } end def render ( assigns ) do ~H&quot;&quot;&quot; &lt;section&gt; &lt;h1&gt;Sign Up&lt;/h1&gt; &lt;.live_component module={SupportComponent} id=&quot;support-component&quot; /&gt; &lt;.live_component module={RegistrationComponent} id=&quot;registration-component&quot; app={MyApp} disabled={@passkeys_supported == false} /&gt; &lt;/section&gt; &quot;&quot;&quot; end def handle_info ( { :passkeys_supported , true } , socket ) do { :noreply , socket |&gt; assign ( :passkeys_supported , true ) } end def handle_info ( { :passkeys_supported , false } , socket ) do { :noreply , socket |&gt; assign ( :passkeys_supported , false ) |&gt; put_flash ( :error , &quot;Sorry, passkeys are not supported or enabled by this browser.&quot; ) } end def handle_info ( { :registration_successful , key_id : raw_id , public_key : public_key , user_handle : user_handle } , socket ) do # Persist the user here. end def handle_info ( { :registration_failure , message : message } , socket ) do # Display the error message. end def handle_info ( { :error , payload } , socket ) do # Display the error message. end end","ref":"usage.html#combined-example","title":"Usage - Combined Example","type":"extras"},{"doc":"On its own, SupportComponent only reports whether the WebAuthn API is supported and enabled by the client. This may be useful for redirecting users away from traditional authentication for businesses mandating Passkey usage whenever possible.","ref":"usage.html#supportcomponent","title":"Usage - SupportComponent","type":"extras"},{"doc":"","ref":"usage.html#tokencomponent","title":"Usage - TokenComponent","type":"extras"},{"doc":"","ref":"usage.html#registrationcomponent","title":"Usage - RegistrationComponent","type":"extras"},{"doc":"","ref":"usage.html#authentication-component","title":"Usage - Authentication Component","type":"extras"}]